export interface MemoizeOptions<A extends unknown[], R, H = unknown> {
    /**
     * Provides a single value to use as the Key for the memoization.
     * Defaults to `JSON.stringify` (ish).
     */
    hash?: (...args: A) => H;
    /**
     * The Cache implementation to provide. Must be a Map or Map-alike.
     * Defaults to a Map. Useful for replacing the cache with an LRU cache or similar.
     */
    cache?: Map<H, R>;
}
export declare type MemoizableFunction<A extends unknown[], R extends unknown, T extends unknown> = (this: T, ...args: A) => R;
export declare function defaultHash<A extends unknown[], H extends unknown>(...args: A): H;
export default function memoize<A extends unknown[], R extends unknown, T extends unknown, H extends unknown>(fn: MemoizableFunction<A, R, T>, opts?: MemoizeOptions<A, R, H>): MemoizableFunction<A, R, T>;
//# sourceMappingURL=index.d.ts.map